YUI.add('contacts-model', function (Y, NAME) {

"use strict";
var Contact = Y.Base.create('contactModel', Y.Base, [], {
    initializer: function(cfg) {

        if (cfg && cfg.json) {
            this.set('_original', Y.JSON.parse(cfg.json));
        }

    }
}, {
    ATTRS: {
        _original: {}
    },
    get: function(contact_id, on_success, on_failure) {
        return Y.io('/contacts/api/' + contact_id, {
            on: {
                success: function(id, response) {
                    var contact = new Contact({
                        json: response.responseText
                        });
                    on_success(contact);
                },
                failure: function(id, response ) {
                    on_failure(response);
                }
            }});
    },
    getAll: function(on_success, on_failure) {
        return Y.io('/contacts/api/all', {
            on: {
                success: function(id, response) {
                    var contacts = Y.JSON.parse(response.responseText);
                    on_success(contacts);
                },
                failure: function(id, response) {
                    on_failure(response);
                }
            }});
    },
    getAllByLetter: function(letter, on_success, on_failure) {
        return Y.io('/contacts/api/by-letter/' + letter, {
            on: {
                success: function(id, response) {
                    var contacts = Y.JSON.parse(response.responseText);
                    on_success(contacts);
                },
                failure: function(id, response) {
                    on_failure(response);
                }
            }});
    }
});
Y.Contact = Contact;


}, '@VERSION@', {
    "requires": [
        "base-base",
        "base-pluginhost",
        "base-build",
        "io-base",
        "io-xdr",
        "io-form",
        "io-upload-iframe",
        "io-queue",
        "json-parse"
    ]
});
