YUI.add('dialog', function (Y, NAME) {

"use strict";
var exports = Y.namespace('One'),

CLICKOUTSIDEEVENTHANDLE = 'clickOutsideEventHandle',
ClickOutside = Y.Base.create('clickOutside', Y.Base, [], {
    initializer: function() {
        this.on('renderedChange', this._onRenderedChangeClickOutside, this);
        this.on('visibleChange', this._onVisibleChangeClickOutside, this);
    },
    destructor: function() {
        this.detach('renderedChange');
        this.detach('visibleChange');
    },
    _onRenderedChangeClickOutside: function() {
        if (this.get('visible') === true) {
            this._attachClickOutsideEvent();
        }
    },
    _onVisibleChangeClickOutside: function(e) {
        if (e.newVal === true) {
            this._attachClickOutsideEvent();
        } else {
            this._detachClickOutsideEvent();
        }
    },
    _attachClickOutsideEvent: function() {
        this.set(
            CLICKOUTSIDEEVENTHANDLE,
            this.get('boundingBox').on('clickoutside', this.destroy, this)
        );
    },
    _detachClickOutsideEvent: function() {
        this.get(CLICKOUTSIDEEVENTHANDLE).detach();
    }
}, {
    ATTRS: {
        clickOutsideEventHandle: { value: null }
    }
});

exports.Dialog = Y.Base.create('dialog', Y.Widget, [
                               Y.WidgetStdMod, Y.WidgetPosition, Y.WidgetStack,
                               Y.WidgetPositionAlign, Y.WidgetPositionConstrain,
                               ClickOutside
]);



}, '@VERSION@', {
    "requires": [
        "base-build",
        "event-outside",
        "widget-base",
        "widget-htmlparser",
        "widget-uievents",
        "widget-skin",
        "widget-stdmod",
        "widget-stack",
        "widget-position-align",
        "widget-position-constrain"
    ]
});
