YUI.add('morelinks', function (Y, NAME) {

"use strict";
/**
 * Module to hide more than "n" list items and provide a link to show
 * and hide the hidden lis.
 *
 * Text for the link can be passed in to facilitate i10n when we get to that.
 *
 */

var namespace = Y.namespace('MoreLinks'),
    elms;

    namespace.init = function(selector, maxLinks, lessText, moreText) {
    elms = Y.all(selector);
    maxLinks = maxLinks || 3;
    moreText = (moreText || "More");
    lessText = (lessText || "Less");

    elms.each(function(elm){
        var elmId = elm.generateID(), lis = elm.all("li"), collapsibleElms, firstItem;
        if (lis){
            collapsibleElms = lis.slice(maxLinks);
            if (collapsibleElms && collapsibleElms.size && collapsibleElms.size() > 1){
                firstItem = true;
                collapsibleElms.each(function(li){
                    if (firstItem === true) {
                        var liMore = Y.Node.create("<li class='more'><a href='#'>" + moreText + "</a></li>");
                        li.insert(liMore, 'before');
                        Y.on("click", function(e){
                            var link = e.currentTarget;
                            e.preventDefault();
                            e.stopPropagation();
                            if (link.getContent().indexOf(moreText) > -1){
                                link.setContent(lessText);
                            } else {
                                link.setContent(moreText);
                            }
                            link.get("parentNode").toggleClass("less");
                            Y.all("#" + elmId + " .collapsible").each(function(liElm){
                                liElm.toggleClass("hidden");
                            });
                            // Toggle a redraw for IE8
                            if (Y.UA.ie === 8) {
                                li.get("parentNode").toggleClass("redraw");
                            }
                        }, liMore.one("a"));
                        firstItem = false;
                    }
                    li.addClass("hidden");
                    li.addClass("collapsible");
                });
            }
        }
    });
};


}, '@VERSION@', {"requires": ["node-base", "node-event-delegate", "node-pluginhost", "node-screen", "node-style"]});
