YUI.add('music-io-v2', function (Y, NAME) {

    "use strict";
    var namespace = Y.namespace('Music');
    namespace.DataSourceV2 = Y.Base.create('DataSourceV2', Y.DataSource.IO, [], {
        _defDataFn: function(e) {
            var data = e.data,
                meta = e.meta,
                response = {
                    results: (Y.Lang.isArray(data)) ? data: [data],
                    meta: meta || {}
                };
            try {
                response.json = Y.JSON.parse(e.data.responseText).response;
                response.meta = Y.JSON.parse(e.data.responseText).meta;
                if (response.json.error) {
                    Y.Global.fire('one:error', {
                        message: response.json.error.message
                    });
                    Y.Do.Halt('An error in the API caused a halt');
                    return;
                }
            } catch(ex) {}
            this.fire('response', Y.mix({
                'response': response}, e));
        },
        getSongs: function(cfg) {
            cfg = cfg || {};

            var limit = cfg.limit || 0,
                offset = cfg.offset || 0;

            this.sendRequest({
                request: 'songs/?limit=' + limit + '&offset=' + offset,
                callback: {
                    success: cfg.success,
                    failure: cfg.failure
                }
            });
        }
    }, {
        ATTRS: {
            plugins: [
                {fn: Y.Plugin.DataSourceCache, cfg: { max: 25 }}
            ],
            source: { value: '/api/music/v2/' }
        }
    });


}, '@VERSION@', {
    "requires": [
        "datasource-local",
        "datasource-io",
        "datasource-get",
        "datasource-function",
        "datasource-cache",
        "datasource-jsonschema",
        "datasource-xmlschema",
        "datasource-arrayschema",
        "datasource-textschema",
        "datasource-polling"
    ]
});
