YUI.add('photos-album-app-view', function (Y, NAME) {

"use strict";
var AlbumAppView = Y.Base.create('albumAppView', Y.View, [], {

    events: {
        '.public-info': {
            click: 'onShareLinkClick'
        }
    },

    initializer: function() {

        var photoList = this.get('photoList');

        this.photosListView = new Y.Photos.PhotosListView({ photoList: photoList });
        this.actionsView = new Y.Photos.AlbumActionsView({ photoList: photoList });
        this.pagerView = new Y.Photos.AlbumPagerView({ photoList: photoList });
        this.galleryView = new Y.Photos.AlbumGalleryView({ photoList: photoList });

        this.photosListView.addTarget(this);
        this.actionsView.addTarget(this);
        this.pagerView.addTarget(this);
        this.galleryView.addTarget(this);

        // remove fallback buttons
        //container.all('button').remove();

    },

    render: function (app) {

        this.photosListView.render(app);
        this.actionsView.render();
        this.pagerView.render(app);
    },

    onShareLinkClick: function(e) {
       this.fire('share:default');
       e.halt();
    }

}, {
    ATTRS: {
        container: {
            value: '.main-cont'
        }
    }
});

Y.namespace('Photos').AlbumAppView = AlbumAppView;


}, '@VERSION@', {
    "requires": [
        "view",
        "photos-album-actions-view",
        "photos-album-pager-view",
        "photos-album-gallery-view",
        "photos-photos-list-view"
    ]
});
