YUI.add('photos-album-pager-view', function (Y, NAME) {

"use strict";
/*
    Represents the pager in an album
*/
var AlbumPagerView = Y.Base.create('albumPagerView', Y.View, [], {

    initializer: function () {

        this.pagerNodes = Y.all(this.get('containers'));
        this.photoList = this.get('photoList');
    },

    buildURLTemplate: function (currentQueryString) {
        var pageParameterRegex = /page\=\d+/,
            pageParameterSubstitute = 'page={page}',
            ret;

        // found page parameter
        if(pageParameterRegex.test(currentQueryString)) {
            ret = currentQueryString.replace(pageParameterRegex, pageParameterSubstitute);
        }
        // append page parameter
        else {
            ret = currentQueryString + '&' + pageParameterSubstitute;
        }
        return '?' + ret;
    },

    render: function (app) {

        var total = this.photoList.get('total'),
            pagesize = this.photoList.get('pagesize'),
            page = this.photoList.get('page');

        if(total > pagesize) {
            // create one or two new Pages object, which then will replace the pager
            // Y.Pages does strict comparison, so make sure they're all Numbers
            this.pagerNodes.each(function (node) {
                new Y.Pages({
                    page: page,
                    pageSize: pagesize,
                    srcNode: node,
                    totalItems: total,
                    URLTemplate: this.buildURLTemplate(app.getQueryString())
                });
            }, this);
        }
    }

}, {
    ATTRS: {
        // note containerS, since this view will serve both
        // it could be one view pr pager
        containers: {
            value: '.paging'
        }
    }
});

Y.namespace('Photos').AlbumPagerView = AlbumPagerView;


}, '@VERSION@', {"requires": ["view"]});
