YUI.add('photos-gallery-meta-view', function (Y, NAME) {

"use strict";
var GalleryMetaView = Y.Base.create('galleryMetaView', Y.View, [], {

    templates: {
        meta: Y.one('#meta-template').getContent(),
        metaShareLink: Y.one('#meta-share-link-template').getContent()
    },

    events: {
        '.action-get-permalink': {
            click: function(e) {
                this.fire('share:default');
                e.halt();
            }
        }
    },

    /**
    Renders the author name and date stuff, called manually by the middleware and whenever a main photo is loaded

    @method renderMeta
    @chainable
    @param {Photo} photo
    @return {PhotosGalleryView} PhotosGalleryView
    **/

    render: function () {

        var photo = this.get('photoList').get('current_photo'),
            newMeta,
            templateData = {
                name: photo.name,
                owner: photo.owner,
                created: Y.Date.format(new Date(photo.last_modified * 1000), {
                    format: '%A %B %d, %Y'
                })
            },
            template;

        if (photo.public_url && !this.get('photoList').get('public_list')) {
            template = this.templates.metaShareLink;
            templateData.sharelink = photo.public_url;
        } else {
            template = this.templates.meta;
        }

        newMeta = Y.Node.create(Y.substitute(template, templateData, function(k,v){return Y.Escape.html(v);}));

        this.get('container').setContent(newMeta);

        return this;
    }

}, {
    ATTRS: {
        container: {
            value: '.photo-meta'
        }
    }
});

Y.namespace('Photos').GalleryMetaView = GalleryMetaView;


}, '@VERSION@', {"requires": ["view", "substitute", "datatype-date-format"]});
