YUI.add('photos-sync', function (Y, NAME) {

"use strict";
function Sync() {}

Sync.prototype = {
    photosURL: '/',

    buildURL: function () {
        return this.photosURL;
    },

    sync: function(action, options, callback) {
        var uri, token, path,
            tokenNode = Y.one('[name=csrfmiddlewaretoken]');

        token = tokenNode ? tokenNode.get('value') : null;

        if (action === 'read') {

            uri = this.buildURL();

            Y.io(uri, {
                data: {
                    'csrfmiddlewaretoken': token
                },
                on: {
                    complete: function(id, e) {
                        var data;

                        data = JSON.parse(e.responseText);
                        if (data) {
                            callback(null, data);
                        } else {
                            callback('sync.js: read io failed');
                        }
                    }
                }
            });
        }

        if (action === 'publish' || action === 'unpublish') {
            uri = this.buildURL();

            path = options.path || '';

            Y.io(uri, {
                method: 'POST',
                data: {
                    'csrfmiddlewaretoken': token,
                    'public': (action === 'publish') ? 'true' : 'false',
                    'path': path
                },
                on: {
                    success: function(id, e) {
                        var data = JSON.parse(e.responseText);
                        if (data) {
                            callback(null, data);
                        } else {
                            callback('sync.js: publish failed');
                        }
                    },
                    failure: function(id, res, args) {
                        console.log('failure');
                        console.log(res.statusText);
                        console.log(args);
                    }
                }
            });
        }
    }
};

Y.namespace('Photos').Sync = Sync;


}, '@VERSION@', {"requires": ["io", "dataschema-json"]});
