YUI.add('plugin-panel-anim', function (Y, NAME) {

"use strict";
var PanelAnim = Y.Base.create("animPanelPlugin", Y.Plugin.Base, [], {

    initializer : function() {

        // Override Widget's _uiSetVisible method, with the custom animated method
        this.beforeHostMethod("_uiSetHostVisibleModal", this._uiAnimSetHostVisibleModal);
    },

    /**
     * Performs events attaching/detaching, stack shifting and mask repositioning based on
     * the visibility of the widget, with a stock transistion
     *
     * @method _uiSetHostVisibleModal
     * @param {boolean} Whether the widget is visible or not
     */

    _uiAnimSetHostVisibleModal : function (visible) {
        var host = this.get('host'),
        stack = host.STACK,
        maskNode = host.get('maskNode'),
        isModal  = host.get('modal'),
        topModal, index;


        if (visible) {

            if (stack && stack.length) {
                Y.Array.each(stack, function(modal){
                    modal._detachUIHandlesModal();
                    modal._blur();
                });
                stack.unshift(host);
            }

            // push on top of stack

            host._repositionMask(host);
            host._uiSetHostZIndexModal(host.get('zIndex'));

            if (isModal) {
                maskNode.show('easein', {
                    duration: 0.3,
                    easing: 'ease-in',
                    opacity: 0.3
                });
                Y.later(1, host, '_attachUIHandlesModal');
                host._focus();
            }


        } else {

            if (stack && stack.length) {
                index = Y.Array.indexOf(stack, host);
                if (index >= 0) {
                    // Remove modal widget from global stack.
                    stack.splice(index, 1);
                }
            }


            host._detachUIHandlesModal();
            host._blur();

            if (stack && stack.length) {
                topModal = stack[0];
                host._repositionMask(topModal);
                //topModal._attachUIHandlesModal();
                topModal._uiSetHostZIndexModal(topModal.get('zIndex'));

                if (topModal.get('modal')) {
                    //topModal._attachUIHandlesModal();
                    Y.later(1, topModal, '_attachUIHandlesModal');
                    topModal._focus();
                }

            } else {

                if (maskNode.getStyle('display') === 'block') {
                    maskNode.hide('fadeOut');
                }

            }

        }
        return new Y.Do.Prevent();
    }
}, {
    NS: 'PanelAnim'
    // TODO consider attrs for anim config
});

Y.namespace('U1Plugin');
Y.U1Plugin.PanelAnim = PanelAnim;


}, '@VERSION@', {"requires": ["plugin", "base-build", "event-custom", "transition"]});
