YUI.add('html5-details', function (Y, NAME) {

"use strict";
var Details = function () {
        Details.superclass.constructor.apply(this, arguments);
    },
    OPEN = 'open';

Y.extend(Details, Y.Base, {

    initializer: function () {

        this.on('destroy', function (e) {

            if(e.target.evtHandle) {
                e.target.evtHandle.detach();
            }

        });

    },

    enable: function () {
        if (!(OPEN in Y.config.doc.createElement('details'))) {
            this._bind();
        }
    },

    _bind: function () {
        this.evtHandle = Y.one('body').delegate('click', this._handler, 'summary');
    },

    _handler: function () {

        var details = this.get('parentNode');

        if(details.getAttribute(OPEN)) {
            details.removeAttribute(OPEN);
        } else {
            details.setAttribute(OPEN, OPEN);
        }

    },

    destructor: function () {
        Y.one('body').detach('click', this._handler);
    },

    evtHandle: null

});

Y.namespace('HTML5').Details = Details;


}, '@VERSION@', {"requires": ["base", "node", "event"]});
