Y.GaTracking = {

    defaults: {

        // ga.js event category
        category: '',

        // DOM event to track
        type: 'click',

        // whether or not to wait 100 ms before following a link
        delayNavigation: true,

        // return information from the clicked target
        // A target can consist of label, val and nonInteraction
        collect: function (target) {
            return {
                label: target.getData('ga-label') || target.get('text'),
                link: target.getAttribute('href')
            };
        },

        // manually set label
        // takes presedence over the collected label
        label: null,

        // connect UI or DOM events to a handler
        bind: function () {
            Y.delegate(this.type, this.handler, this.container, this.target, this);
        },

        // event handler
        handler: function (e) {

            var c = this.collect(e.target);

            if(c.link && this.delayNavigation) {
                e.preventDefault();
                Y.later(100, e.target, function () {
                    Y.config.doc.location.href = c.link;
                });
            }

            this.push(this.label || c.label, c.val, c.nonInteractive);

        },

        push: function (label, val, nonInteractive) {
            Y.config.win._gaq.push(['_trackEvent', this.category, this.action, label, val, nonInteractive]);
        }

    },

    configs: [],

    track: function () {
        Y.each(this.configs, Y.bind(this._track, this));
    },

    _track: function (config) {

        config = config || {};

        if(!Y.one(config.container)) {
            return;
        }

        config = Y.merge(this.defaults, config);

        Y.bind(config.bind, config)();
    },

    add: function (config) {
        this.configs.push(config);
    },

    destroy: function () {

        // detach
        Y.each(this.configs, function (c) {
            var n = Y.one(c);
            if(n) {
                n.detach(c.type, c.handler);
            }
        });

        this.configs = [];
    }
};
