'use strict';

(function() {


    var detailsSupport = ('open' in YUI().config.doc.createElement('details'));
    var describeDetails = (!detailsSupport ? describe : describe.skip);

    describeDetails('html5-details', function() {

        var Y;
        var html;

        before(function (done) {


            Y = YUI().use('html5-details', 'node-event-simulate', function(Y) {

                html = Y.Node.create('<div id="test" />');
                Y.one('body').append(html);

                done();

            });
        });

        beforeEach(function (done) {

            html.append(Y.Node.create('<details><summary>Foo</summary><p>Bar</p></details>'));
            done();

        });

        afterEach(function (done) {

            html.empty();
            done();

        });

        describeDetails('Y.HTML5.Details', function () {

            it('should be loaded', function() {

                expect(Y.HTML5.Details).to.exist;

            });

            it('should be instantiable', function() {

                expect(new Y.HTML5.Details()).to.be.ok;

            });

        });

        describeDetails('#click()', function () {

            var d;

            beforeEach(function (done) {

                d = new Y.HTML5.Details();
                d.enable();

                done();

            });

            afterEach(function (done) {

                d.destroy();
                done();

            });

            it('should close', function() {

                html.one('details').setAttribute('open', 'open');

                html.one('summary').simulate('click');

                expect(html.one('details').hasAttribute('open')).to.be.false;

            });

            it('should open', function() {

                html.one('summary').simulate('click');

                expect(html.one('details').hasAttribute('open')).to.be.true;

            });

        });

    });
})();
