'use strict';

(function() {
    describe('overlay-extras', function() {
        var Y;

        before(function(done) {
            Y = YUI().use(
                'overlay-extras', 'overlay', function(Y) {
                done();
            });
        });

        describe('Plugin objects', function () {

            it('should be loaded', function() {
                expect(Y.Plugin.OverlayModal).to.exist;
                expect(Y.Plugin.OverlayKeepaligned).to.exist;
                expect(Y.Plugin.OverlayAutohide).to.exist;
                expect(Y.Plugin.OverlayPointer).to.exist;
            });

        });

        describe('OverlayModal', function () {

            var host;
            var bb;
            var plugin;

            beforeEach(function (done) {

                bb = Y.Node.create('<div />');
                host = new Y.Overlay({
                    boundingBox: bb
                });
                plugin = new Y.Plugin.OverlayModal({
                    'host': host
                });

                done();

            });

            afterEach(function (done) {

                host && host.destroy();
                done();

            });

            it('should be instantiable', function() {
                expect(plugin).to.exist;
            });

        });

        describe('OverlayAutohide', function () {

            var host;
            var bb;
            var plugin;

            beforeEach(function (done) {

                bb = Y.Node.create('<div />');
                host = new Y.Overlay({
                    boundingBox: bb
                });
                plugin = new Y.Plugin.OverlayAutohide({
                    'host': host
                });

                done();

            });

            afterEach(function (done) {

                host && host.destroy();
                done();

            });

            it('should be instantiable', function() {
                expect(plugin).to.exist;
            });

        });

        describe('OverlayPointer', function () {

            var host;
            var bb;
            var plugin;

            beforeEach(function (done) {

                bb = Y.Node.create('<div />');
                host = new Y.Overlay({
                    boundingBox: bb
                });
                plugin = new Y.Plugin.OverlayPointer({
                    'host': host
                });

                done();

            });

            afterEach(function (done) {

                host && host.destroy();
                done();

            });

            it('should be instantiable', function() {
                expect(plugin).to.exist;
            });

        });

        describe('OverlayKeepaligned', function () {

            var host;
            var bb;
            var plugin;

            beforeEach(function (done) {

                bb = Y.Node.create('<div />');
                host = new Y.Overlay({
                    boundingBox: bb
                });
                plugin = new Y.Plugin.OverlayKeepaligned({
                    'host': host
                });

                done();

            });

            afterEach(function (done) {

                host && host.destroy();
                done();

            });

            it('should be instantiable', function() {
                expect(plugin).to.exist;
            });

        });

    });
})();
