/**
 * very simple plugin to collapse a node witha given transition type
 */
Y.namespace('Plugin').Collapse = Y.Base.create('collapse', Y.Plugin.Base, [], {
    initializer: function() {
        this.host = this.get('host');

        this.state = this.get('state') || null;

        this.config = this.getAttrs(['easing', 'duration']);

        this.host.addClass('collapse');
        // if state is set to closed/false, set height to 0
        if (!this.get('state')) {
            this.host.addClass('in');
            this.host.setStyle('height', 0);
        }
        this.publish('open');
        this.publish('close');
        this.publish('toggle');
    },
    open: function() {
        var host = this.host;
        var plugin = this;

        host.removeClass('collapse')
            .addClass('collapsing');

        plugin.config.height = host.get('scrollHeight') + 'px';

        Y.log('open height: ' + plugin.config.height, 'debug', 'plugin-collapse');

        host.transition(plugin.config, function(e) {
            this.replaceClass('collapsing', 'collapse')
                .removeClass('in');

            this.collapse.set('state', true);
            this.collapse.fire('open');
        });
    },
    close: function() {
        var host = this.host;
        var plugin = this;
        plugin.config.height = 0;

        host.removeClass('collapse')
            .addClass('collapsing');

        host.transition(this.config, function() {
            this.replaceClass('collapsing', 'collapse')
                .addClass('in');

            this.collapse.set('state', false);
            this.collapse.fire('close');
        });
    },

    toggle: function() {
        if (this.get('state')) {
            this.close();
        } else {
            this.open();
        }
        this.fire('toggle');
    }
}, {
    NS: 'collapse',
    ATTRS: {
        duration: {
            value: '0.2'
        },
        easing: {
            value: 'cubic-bezier'
        },
        state: {
            // truthy if open, falsey if closed
            value: 0
        }
    }
});
