var UploaderMyappsPackagesForExtraction = Y.Base.create('uploaderMyappsPackagesForExtraction', Y.UploaderMyappsPackages, [], {

    _binaryFailureHandler: function (e) {

        var uploader = this._binaryUploader,
            f = '.field-binary';

        this.fire('error', { message: this.get('strings.correct_errors')});

        switch (e.type) {
            case 'uploaderMyappsPackagesForExtraction:nobinary':
                this.fire('error', { message: this.get('strings.binary_none'), field: f });
                break;
            case 'uploaderMyappsPackagesForExtraction:binaryisnullbyte':
                this.fire('error', { message: this.get('strings.binary_nullbyte'), field: f });
                break;
        }

        uploader.once('fileListChange', function () { this.fire('clear'); }, this);
    },

    updateVersion: function () {
        return true;
    },

    submitHandler: function (e) {

        if (Y.one('#id_updown_id').get('value') === '') {
            return UploaderMyappsPackagesForExtraction.superclass.submitHandler.call(this, e);
        }
    },

    setCompleteHandler: function (binFile, srcFile) {
        this._binaryUploader.once('uploadcomplete', function (e) {
            var has_src = Boolean(srcFile) ? "True" : "False",
                binary_filesize = binFile.get('size');

            Y.one('#id_updown_id').set('value', Y.JSON.parse(e.data).upload_id);
            Y.one('#id_binary_filesize').set('value', binary_filesize);
            Y.one('#id_source_uploaded').set('value', has_src);
        }, this);
        this._binaryUploader.once('fullycomplete', function () {
            var form = Y.one('.devportal-form');
            form.submit();
        }, this);
    },

    uploadBinary: function (src) {

        var vars = {};

        // XXX:
        // We need to upload the source file in the same
        // request as the binary. Adding the source file
        // as a parameter accomplishes this
        if(src) {
            vars.source = src.get('file');
        }

        this._binaryUploader.uploadAll(null, vars);

    }

}, {
    ATTRS: {
        strings: { value: null },
        template: { value: null }
    }
});

Y.UploaderMyappsPackagesForExtraction = UploaderMyappsPackagesForExtraction;
